api/urls.py
from django.urls import path
from . import views

app_name = 'api'
urlpatterns = [
    # jwt auth
    path('auth/token-pair/', views.CustomTokenViewBase.as_view(), name='token_pair'),
    path('auth/token-refresh/', views.CustomTokenRefreshView.as_view(), name='token_refresh'),
    # views
    path('budget_entries/', views.BudgetEntryView.as_view(), name='budget_entries'),
    path('aggr_budgets/', views.AggregateBudgetView.as_view(), name='aggr_budgets'),
    path('charts/', views.ChartView.as_view(), name='charts-api')
]

project/urls.py
from django.contrib import admin
from django.urls import path, include
from .yasg import urlpatterns as doc_urls

urlpatterns = [
    path('admin/', admin.site.urls),
    path('purse/', include('purse.urls')),
    path('auth/', include('users.urls')),
    path('api/', include('api.urls')),
    path('api-auth', include('rest_framework.urls')),
    path('social/', include('social_django.urls', namespace='social'))
]

urlpatterns += doc_urls

purse/urls.py
from django.urls import path
from . import views


app_name = 'purse'

urlpatterns = [
    path('', views.IndexPageView.as_view(), name='index'),  # переделал
    # CRUD
    path('profile/add_operations/', views.AddBudgetEntryView.as_view(), name='add_operations'),  # create
    path('create_expense/', views.AddBudgetEntryExpenseView.as_view(), name='add_expense'),  # create
    path('create_income/', views.AddBudgetEntryIncomeView.as_view(), name='add_income'),  # create
    path('profile/<str:user>/<int:year>/<str:slug>/', views.AggrBudgetDetailView.as_view(), name='budget_detail'),  # read
    path('profile/history/', views.HistoryOperationsView.as_view(), name='history'),  # read
    path('profile/change/<str:pk>/', views.BudgetEntryUpdateView.as_view(), name='change_budget_entry'),  # update
    path('profile/delete_budget_entry/<str:pk>/', views.DeleteBudgetEntryView.as_view(), name='delete_budget_entry'),  # delete
    path('profile/delete_aggr_budget/<str:pk>/', views.DeleteAggregateBudgetView.as_view(), name='delete_aggr_budget'),  # delete
    # charts
    path('profile/charts/', views.ChartsView.as_view(), name='charts'),
    # export data
    path('profile/download/<str:pk>/', views.download, name='download'),
    path('profile/filter/', views.FilterBudgetEntriesView.as_view(), name='filter'),
]

users/urls.py
from django.urls import path
from .views import *


app_name = 'users'

urlpatterns = [
    # Вход/выход с сайта
    path('login/', UserLoginView.as_view(), name='login'),
    path('logout/', UserLogoutView.as_view(), name='logout'),
    # Изменить информацию о себе
    path('profile/change/', UserChangeInfo.as_view(), name='change_profile'),
    # Изменить пароля
    path('profile/password/change/', UserPasswordChangeView.as_view(), name='password_change'),
    # Сброс пароля
    path('password/reset/', UserPasswordResetView.as_view(), name='password_reset'),
    path('password/reset/<uidb64>/<token>/', UserPasswordResetConfirmView.as_view(), name='password_reset_confirm'),
    path('password/reset/done/', UserPasswordResetCompleteView.as_view(), name='password_reset_complete'),
    # Регистрация пользователя на сайте
    path('registration/', UserRegistrationView.as_view(), name='user_registration'),
    path('registration/activate/<str:sign>/', user_activate, name='registration_activate'),
]

purse/models.py
from django.db import models
from uuid import uuid4
from pytils.translit import slugify
from users.models import CustomUser
from datetime import datetime
from django.urls import reverse


# Create your models here.
class BudgetCategory(models.Model):
    """Базовая модель категории расходов"""
    TYPES = (
        ('i', 'Доход'),
        ('e', 'Расход')
    )

    type = models.CharField(max_length=1, choices=TYPES, verbose_name='Тип', null=True, blank=True)
    name = models.CharField(max_length=155, verbose_name='Категория', unique=True)
    description = models.CharField(max_length=255, verbose_name='Описание', null=True, blank=True)
    slug = models.SlugField(max_length=155, unique=True)
    super_category = models.ForeignKey('SuperCategory', on_delete=models.PROTECT, null=True, blank=True, related_name='sub_categories', verbose_name='Надкатегория')

    def save(self, commit=False, *args, **kwargs):
        if not self.slug:
            self.slug = slugify(self.name)
        super(BudgetCategory, self).save(*args, **kwargs)


class SuperCategoryManager(models.Manager):
    """Менеджер надкатегорий"""
    def get_queryset(self):
        return super().get_queryset().filter(super_category__isnull=True)


class SuperCategory(BudgetCategory):
    """Модель надкатегории"""
    objects = SuperCategoryManager()

    def __str__(self):
        return self.name

    class Meta:
        proxy = True
        verbose_name = 'Надкатегория'
        verbose_name_plural = 'Надкатегории'


class SubCategoryManager(models.Manager):
    """Менеджер подкатегории"""
    def get_queryset(self):
        return super().get_queryset().filter(super_category__isnull=False)


class SubCategory(BudgetCategory):
    """Модель подкатегории"""
    objects = SubCategoryManager()

    def __str__(self):
        return self.name

    class Meta:
        proxy = True
        verbose_name = 'Подкатегория'
        verbose_name_plural = 'Подкатегории'


class AggregateBudget(models.Model):
    """Аггрегированный бюджет за месяц"""

    id = models.UUIDField(unique=True, default=uuid4, primary_key=True, db_index=True, verbose_name='id')
    month = models.PositiveSmallIntegerField(verbose_name='Месяц')
    year = models.PositiveSmallIntegerField(verbose_name='Год')
    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE, verbose_name='Пользователь')
    income_amount = models.PositiveIntegerField(verbose_name='Сумма дохода', default=0)
    expenses_amount = models.PositiveIntegerField(verbose_name='Сумма расхода', default=0)
    slug = models.SlugField(max_length=155)
    created_at = models.DateTimeField(auto_now_add=True, verbose_name='Дата создания')
    updated_at = models.DateTimeField(auto_now=True, verbose_name='Дата обновления')

    class Meta:
        verbose_name = 'Агрегированный бюджет за месяц'
        verbose_name_plural = 'Агрегированные бюджеты за месяц'
        ordering = ['created_at']

    def get_absolute_url(self):
        user = self.user
        return reverse('purse:budget_detail', kwargs={'user': user, 'year': self.year, 'slug': self.slug})

    def __str__(self):
        return f'Бюджет за {self.slug} {self.year} года'


class BudgetEntry(models.Model):
    """Запись о доходе/расходе"""

    id = models.UUIDField(unique=True, default=uuid4, primary_key=True, db_index=True, verbose_name='id')
    title = models.CharField(max_length=155, verbose_name='Заголовок')
    type = models.CharField(max_length=1, verbose_name='Тип')
    category = models.ForeignKey(SubCategory, on_delete=models.CASCADE, verbose_name='Категория')
    amount = models.PositiveIntegerField(verbose_name='Сумма')

    day_num = models.PositiveIntegerField(verbose_name='Число', blank=True)
    month_num = models.PositiveIntegerField(verbose_name='Месяц число', blank=True)
    month_str = models.CharField(max_length=15, blank=True, verbose_name='Месяц строка')
    year = models.PositiveIntegerField(verbose_name='Год', blank=True)
    week_number = models.PositiveIntegerField(verbose_name='Номер недели', blank=True)
    day_of_week = models.CharField(max_length=15, blank=True, verbose_name='День недели')

    user = models.ForeignKey(CustomUser, on_delete=models.CASCADE, verbose_name='Пользователь', blank=True)
    parent = models.ForeignKey(AggregateBudget, on_delete=models.CASCADE, verbose_name='Агрегированный бюджет', blank=True, related_name='budget_entries')
    created_at = models.DateTimeField(auto_now_add=True, verbose_name='Дата создания', blank=True)
    updated_at = models.DateTimeField(verbose_name='Дата обновления', blank=True, null=True)
    changed = models.BooleanField(default=False, verbose_name='Изменялась')

    class Meta:
        verbose_name = 'Запись о расходе/доходе'
        verbose_name_plural = 'Записи о расходе/доходе'
        ordering = ['created_at']

    def __str__(self):
        return f'{self.user} - {self.id}'

purse/forms.py
from django import forms


from .models import BudgetEntry, SubCategory


class BudgetEntryExpenseForm(forms.ModelForm):
    """Форма для создания записи о доходе/расходе"""
    category = forms.ModelChoiceField(queryset=SubCategory.objects.filter(type='e'), label='Категория')

    class Meta:
        model = BudgetEntry
        fields = ['title', 'type', 'category', 'amount', 'user']
        widgets = {
            'user': forms.HiddenInput,
            'title': forms.TextInput(attrs={'class': 'form-control form-control-sm'}),
            'type': forms.HiddenInput,
            'amount': forms.TextInput(attrs={'class': 'form-control form-control-sm', 'type': 'number'})
        }


class BudgetEntryIncomeForm(forms.ModelForm):
    """Форма для создания записи о доходе/расходе"""
    category = forms.ModelChoiceField(queryset=SubCategory.objects.filter(type='i'), label='Категория')

    class Meta:
        model = BudgetEntry
        fields = ['title', 'type', 'category', 'amount', 'user']
        widgets = {
            'user': forms.HiddenInput,
            'title': forms.TextInput(attrs={'class': 'form-control form-control-sm'}),
            'type': forms.HiddenInput,
            'amount': forms.TextInput(attrs={'class': 'form-control form-control-sm', 'type': 'number'})
        }


class BudgetEntryChangeForm(forms.ModelForm):
    """Форма для изменения записи о доходе/расходе"""

    class Meta:
        model = BudgetEntry
        fields = ['title', 'amount', 'user', 'type']
        widgets = {
            'user': forms.HiddenInput,
            'title': forms.TextInput(attrs={'class': 'form-control form-control-sm'}),
            'amount': forms.TextInput(attrs={'class': 'form-control form-control-sm', 'type': 'number'}),
            'type': forms.HiddenInput
        }

purse/views.py
from django.http import FileResponse
from django.urls import reverse
from django.shortcuts import redirect, render
from django.views.generic.base import TemplateView, View
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib import messages


from . import models
from . import forms
from . import services
from users.forms import CustomUserLoginForm


# Create your views here.
class IndexPageView(TemplateView):
    """Индексная страница, доступна всем"""
    template_name = 'purse/index_page.html'
    extra_context = {'login_form': CustomUserLoginForm, 'section': 'index'}


class AddBudgetEntryView(LoginRequiredMixin, View):
    """Класс для отображения форм для добавления записи о расходе/доходе"""
    def get(self, request):
        form_income = forms.BudgetEntryIncomeForm(self.request.GET or None, initial={'type': 'i', 'user': self.request.user})
        form_expense = forms.BudgetEntryExpenseForm(self.request.GET or None,
                                              initial={'type': 'e', 'user': self.request.user})
        context = {'form_income': form_income, 'form_expense': form_expense, 'section': 'add_operations'}
        context.update(services.SortBudgetEntries(request.user).get_context())
        return render(request, 'purse/add_operations.html', context)


class AddBudgetEntryExpenseView(LoginRequiredMixin, View):
    """Класс для создания записи расхода"""

    def post(self, request):
        form = forms.BudgetEntryExpenseForm(request.POST)
        if form.is_valid():
            new_instance = form.save(commit=False)
            services.ProcessingBudgetEntry(new_instance).create()
            messages.add_message(request, messages.SUCCESS, 'Запись создана')
            return redirect('purse:add_operations')


class AddBudgetEntryIncomeView(LoginRequiredMixin, View):
    """Класс для создания записи дохода"""

    def post(self, request):
        form = forms.BudgetEntryIncomeForm(request.POST)
        if form.is_valid():
            new_instance = form.save(commit=False)
            services.ProcessingBudgetEntry(new_instance).create()
            messages.add_message(request, messages.SUCCESS, 'Запись создана')
            return redirect('purse:add_operations')


class HistoryOperationsView(LoginRequiredMixin, View):
    """Отображение агрегированной истории операция по месяцам"""

    def get(self, request):
        data = services.AggrBudgetsToHistoryView(request.user.pk)
        context = {'data': data.ready_data, 'section': 'history'}
        return render(request, 'purse/history.html', context)


class BudgetEntryUpdateView(LoginRequiredMixin, View):
    """Класс для изменения записи о расходе/доходе"""
    old_instance = None

    def dispatch(self, request, *args, **kwargs):
        pk = self.kwargs.get('pk')
        self.old_instance = services.get_budget_entry(pk)
        return super().dispatch(request, *args, **kwargs)

    def get(self, request, pk):
        form = forms.BudgetEntryChangeForm(instance=self.old_instance)
        context = {'form': form, 'category': self.old_instance.category, 'back_url': self.old_instance.parent.get_absolute_url()}
        return render(request, 'purse/change_budget_entry.html', context)

    def post(self, request, pk):
        new_instance = forms.BudgetEntryChangeForm(request.POST, instance=self.old_instance)

        if new_instance.is_valid():
            new_instance = new_instance.save(commit=False)
            services.ProcessingBudgetEntry(new_instance).update()
            messages.add_message(request, messages.SUCCESS, 'Запись обновлена')
            return redirect(reverse('purse:budget_detail', kwargs={'user': self.old_instance.parent.user,
                                                                   'year': self.old_instance.parent.year,
                                                                   'slug': self.old_instance.parent.slug}))
        else:
            return redirect('purse:history')


class DeleteBudgetEntryView(LoginRequiredMixin, View):
    """Класс для удаления записи о доходе/расходе"""
    old_instance = None

    def dispatch(self, request, *args, **kwargs):
        pk = self.kwargs.get('pk')
        self.old_instance = services.get_budget_entry(pk)
        return super().dispatch(request, *args, **kwargs)

    def get(self, request, pk):
        instance = services.get_budget_entry(pk)
        services.ProcessingBudgetEntry(instance).delete()
        return redirect(reverse('purse:budget_detail', kwargs={'user': self.old_instance.parent.user,
                                                               'year': self.old_instance.parent.year,
                                                               'slug': self.old_instance.parent.slug}))


class DeleteAggregateBudgetView(LoginRequiredMixin, View):
    """Класс для удаления агрегированного бюджета за месяц"""
    old_instance = None

    def dispatch(self, request, *args, **kwargs):
        pk = self.kwargs.get('pk')
        self.old_instance = services.get_aggr_budget(pk)
        return super().dispatch(request, *args, **kwargs)

    def get(self, request, pk):
        aggr_budget = self.old_instance
        self.old_instance.delete()
        return redirect('purse:history')


class TypeCategory:
    def get_types(self):
        return models.BudgetEntry.objects.distinct('type').order_by('type').values('type')

    def get_categories(self):
        return models.SubCategory.objects.distinct('name').order_by('name').values('name')


class AggrBudgetDetailView(TypeCategory, LoginRequiredMixin, ListView):
    template_name = 'purse/budget_detail.html'
    extra_context = {'section': 'history'}
    paginate_by = 6

    def get_queryset(self):
        return models.BudgetEntry.objects.filter(
            user=self.request.user.pk,
            year=self.kwargs['year'],
            month_str=self.kwargs['slug']
        )


class FilterBudgetEntriesView(TypeCategory, LoginRequiredMixin, ListView):
    """Класс для фильтра записей о доходе/расходе"""
    template_name = 'purse/budget_detail.html'
    extra_context = {'section': 'history'}
    paginate_by = 6

    def get_queryset(self):
        queryset = models.BudgetEntry.objects.filter(user=self.request.user, type__in=self.request.GET.getlist('type'))
        return queryset

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data()
        return context


class ChartsView(LoginRequiredMixin, View):
    """Графики"""
    def get(self, request, *args, **kwargs):
        return render(request, 'purse/charts.html', {'section': 'charts'})


def download(request, pk):
    aggr_budget = models.AggregateBudget.objects.get(id=pk)
    user = aggr_budget.user
    month = aggr_budget.slug
    year = aggr_budget.year
    budget_entries = list(aggr_budget.budget_entries.all())
    data = [services.to_dict(i) for i in budget_entries]
    file_dir = services.generate_excel(data, user, month, year)
    file = open(file_dir, 'rb')
    return FileResponse(file)

templates/purse/add_operations.html
{% extends 'base.html' %}
{% load bootstrap4 %}
{% load static %}

{% block title %}Создание записи{% endblock %}

{% block content %}

<div class="row">
    <div class="col">
        <div class="jumbotron p-4 p-md-5 text-dark rounded bg-white-50">
            <div class="row">
                <div class="col-md-12 px-0">
                    <h4 class="display-5 font-italic">Добавить запись о расходе/доходе, посмотреть историю за текущий
                        месяц</h4>
                </div>
            </div>
            <div class="row">
                <div class="col-md-4 px-0">
                    <ul class="nav nav-tabs">
                        <li class="nav-item" role="presentation">
                            <a class="nav-link active text-muted text-decoration-none f-hover" id="home-tab" data-toggle="tab" href="#home" role="tab"
                               aria-controls="home"
                               aria-selected="true">Расход</a>
                        </li>
                        <li class="nav-item" role="presentation">
                            <a class="nav-link text-muted text-decoration-none f-hover" id="profile-tab" data-toggle="tab" href="#profile" role="tab"
                               aria-controls="profile"
                               aria-selected="false">Доход</a>
                        </li>
                    </ul>
                    <div class="tab-content">
                        <div class="tab-pane fade show active" id="home" role="tabpanel" aria-labelledby="home-tab">
                            <form method="post" class="mt-3" action="{% url 'purse:add_expense' %}">
                                {% csrf_token %}
                                {% bootstrap_form form_expense show_label=True size='small' layout='horizontal' %}
                                {% bootstrap_button 'Добавить' button_class='btn btn-sm btn-outline-secondary' button_type='submit' size='small' %}
                            </form>
                        </div>
                        <div class="tab-pane fade" id="profile" role="tabpanel" aria-labelledby="profile-tab">
                            <form method="post" class="mt-3" action="{% url 'purse:add_income' %}">
                                {% csrf_token %}
                                {% bootstrap_form form_income show_label=True size='small' layout='horizontal' %}
                                {% bootstrap_button 'Добавить' button_class='btn btn-sm btn-outline-secondary' button_type='submit' size='small' %}
                            </form>
                        </div>
                    </div>
                </div>
                <div class="col-md-1 px-0 border-right border-secondary"></div>
                <div class="col-md-1 px-0 border-left border-secondary"></div>
                <div class="col-md-6 px-0">
                    {% if balance is not none %}
                    <div class="row">
                        <div class="col">
                            <h4 class="h4 mt-3">Баланс на текущий месяц: <span
                                    class="{% if balance > 0 %}badge badge-success{% elif balance < 0 %}badge badge-danger{% else %} badge badge-secondary{% endif %}">{{ balance }}</span>
                                ₽</h4>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col">
                            <button class="btn btn-sm btn-outline-secondary" type="button" data-toggle="collapse"
                                    data-target="#incomes"
                                    aria-expanded="false" aria-controls="collapseExample">Доходы: <span
                                    class="badge badge-light">{{ total_income }} ₽</span>
                            </button>
                            <div class="collapse" id="incomes">
                                {% for key, value in incomes_per_category.items %}
                                <div>
                                    <span class="badge badge-pill badge-success">{{ key }}: {{ value }} ₽</span>
                                </div>
                                {% endfor %}
                            </div>
                        </div>
                        <div class="col">
                            <button class="btn btn-sm btn-outline-secondary" type="button" data-toggle="collapse"
                                    data-target="#expense"
                                    aria-expanded="false" aria-controls="collapseExample">Затраты: <span
                                    class="badge badge-light">{{ total_expense }} ₽</span>
                            </button>
                            <div class="collapse" id="expense">
                                {% for key, value in expenses_per_category.items %}
                                <div>
                                    <span class="badge badge-pill badge-danger">{{ key }}: {{ value }} ₽</span>
                                </div>
                                {% endfor %}
                            </div>
                        </div>
                    </div>
                    {% else %}
                    <div class="row">
                        <div class="col">
                            <h4 class="h4 mt-3">Текущий месяц: </h4>
                            <small>Данных за текущий месяц нет</small>
                        </div>
                    </div>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

templates/purse/budget_detail.html
{% extends 'base.html' %}
{% load static %}
{% load bootstrap4 %}

{% block content %}

<div class="row">
    <div class="col-2">
        <div class="row">
            <div class="col">
                <p class="h5">Filters</p>
                <div class="dropdown-divider"></div>
                <h4><small class="text-muted">Тип</small></h4>
                <form action="{% url 'purse:filter' %}" method="get" class="mb-3">
                    {% for value in view.get_types %}
                    <div class="custom-control custom-checkbox">
                        <input type="checkbox" class="custom-control-input" id="{{ value.type }}" name="type" value="{{ value.type }}">
                        <label class="custom-control-label" for="{{ value.type }}">{% if value.type == 'i' %}Доход{% else %}Расход{% endif %}</label>
                    </div>
                    {% endfor %}
                    <h4><small class="text-muted">Категория</small></h4>
                    {% for value in view.get_categories %}
                    <div class="custom-control custom-checkbox">
                        <input type="checkbox" class="custom-control-input" id="{{ value.name }}">
                        <label class="custom-control-label" for="{{ value.name }}">{{ value.name }}</label>
                    </div>
                    {% endfor %}
                    <button class="btn btn-sm btn-outline-secondary mt-2" type="submit">Показать</button>
                </form>
            </div>
        </div>
    </div>
    <div class="col-10" style="min-height: 832.5px">
    <div class="row">
        <div class="col">
            <div class="row">
                <div class="col text-left">
                    <a href="{% url 'purse:history' %}" class="btn btn-sm btn-outline-secondary">Назад</a>
                </div>
                <div class="col text-right">
                    <p class="h5">Детализация за {{ object_list.0.month_str }} {{ object_list.0.year }} года:</p>
                </div>
            </div>
            <div class="dropdown-divider"></div>
            {% for i in object_list %}
            <div class="card mb-1">
                <div class="{% if i.type == 'i' %}card-body border border-success{% else %}card-body border border-danger{% endif %}">
                    <div class="row">
                        <div class="col-2 px-1">
                            <small class="form-text text-muted">Название: </small>
                            <small>{{ i.title }}</small>
                        </div>
                        <div class="col-1 px-1">
                            <small class="form-text text-muted">Тип: </small>
                            <small>{% if i.type == 'i' %}Доход{% else %}Расход{% endif %}</small>
                        </div>
                        <div class="col-2 px-1">
                            <small class="form-text text-muted">Категория: </small>
                            <small>{{ i.category }}</small>
                        </div>
                        <div class="col-1 px-1">
                            <small class="form-text text-muted">Сумма: </small>
                            <small>{{ i.amount }} ₽</small>
                        </div>
                        <div class="col-2 px-1">
                            <small class="form-text text-muted">Дата: </small>
                            <small>{{ i.created_at|date:"d.m.Y" }}</small>
                        </div>
                        <div class="col-2 px-1">
                            <small class="form-text text-muted">День недели: </small>
                            <small>{{ i.created_at|date:"l" }}</small>
                        </div>
                        <div class="col-2 text-right p-0">
                            <a href="{% url 'purse:change_budget_entry' i.id %}" class="btn btn-sm btn-outline-info mt-3" title="Изменить">
                                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-pencil-square"
                                     fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                                    <path d="M15.502 1.94a.5.5 0 0 1 0 .706L14.459 3.69l-2-2L13.502.646a.5.5 0 0 1 .707 0l1.293 1.293zm-1.75 2.456l-2-2L4.939 9.21a.5.5 0 0 0-.121.196l-.805 2.414a.25.25 0 0 0 .316.316l2.414-.805a.5.5 0 0 0 .196-.12l6.813-6.814z"/>
                                    <path fill-rule="evenodd"
                                          d="M1 13.5A1.5 1.5 0 0 0 2.5 15h11a1.5 1.5 0 0 0 1.5-1.5v-6a.5.5 0 0 0-1 0v6a.5.5 0 0 1-.5.5h-11a.5.5 0 0 1-.5-.5v-11a.5.5 0 0 1 .5-.5H9a.5.5 0 0 0 0-1H2.5A1.5 1.5 0 0 0 1 2.5v11z"/>
                                </svg>
                            </a>
                            <a href="{% url 'purse:delete_budget_entry' i.id %}" class="btn btn-sm btn-outline-danger mt-3" title="Удалить">
                                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-trash-fill"
                                     fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                                    <path fill-rule="evenodd"
                                          d="M2.5 1a1 1 0 0 0-1 1v1a1 1 0 0 0 1 1H3v9a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V4h.5a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1H10a1 1 0 0 0-1-1H7a1 1 0 0 0-1 1H2.5zm3 4a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 .5-.5zM8 5a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7A.5.5 0 0 1 8 5zm3 .5a.5.5 0 0 0-1 0v7a.5.5 0 0 0 1 0v-7z"/>
                                </svg>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="dropdown-divider"></div>
            {% endfor %}
        </div>
    </div>
        {% if is_paginated %}
    <nav aria-label="...">
        <ul class="pagination pagination-sm">
            {% if not page_obj.has_previous %}
            <li class="page-item disabled">
                <a class="page-link" href="#" tabindex="-1" aria-disabled="true">Предыдущая</a>
            </li>
            {% else %}
            <li class="page-item">
                <a class="page-link" href="?page={{ page_obj.previous_page_number }}" tabindex="-1" aria-disabled="true">Предыдущая</a>
            </li>
            {% endif %}
            {% for n in page_obj.paginator.page_range %}
                {% if page_obj.number == n %}
                    <li class="page-item active custom" aria-current="page">
                        <a class="page-link" href="?page={{ n }}">{{ n }} <span class="sr-only" style="background-color: black">(current)</span></a>
                    </li>
                {% elif n > page_obj.number|add:-3 and n < page_obj.number|add:3 %}
                    <li class="page-item custom"><a class="page-link" href="?page={{ n }}">{{ n }}</a></li>
                {% endif %}
            {% endfor %}

            {% if not page_obj.has_next %}
            <li class="page-item disabled">
                <a class="page-link" href="#" tabindex="-1">Следующая</a>
            </li>
            {% else %}
            <li class="page-item">
                <a class="page-link" href="?page={{ page_obj.next_page_number }}" tabindex="-1">Следующая</a>
            </li>
            {% endif %}
        </ul>
    </nav>
        {% endif %}
    </div>
</div>


<script src="{% static 'purse/js/script.js' %}"></script>

{% endblock %}

templates/purse/delete_aggr_budget.html
{% extends 'base.html' %}

{% block profile_data %}
<form method="post">
    {% csrf_token %}
    <p>Вы уверенны что хотите удалить {{ object }} ?</p>
    <button type="submit" class="btn btn-success btn-sm">Delete</button>
</form>
{% endblock %}